<?php

namespace Fastrack\CalendarEvents;

use SilverStripe\ORM\DataObject;
use SilverStripe\Security\Permission;
use SilverStripe\Security\PermissionProvider;
use SilverStripe\Security\Security;

class CalendarEventCategory extends DataObject implements PermissionProvider
{

	private static $table_name = 'calendar_event_category';

	private static $db = [
		'Name' => 'Varchar(255)',
		'Key' => 'Varchar(255)'
	];

	private static $belongs_many_many = [
		'CalendarEvents' => CalendarEvent::class,
	];

	private static $translate = [
	    'Name',
	];

	public function providePermissions()
	{
		$permisions = [
			'MANAGE_CALENDAR_EVENT_CATEGORIES' => [
				'name' => 'Manage calendar event categories',
				'category' => 'Calendar events',
			],
		];
		$this->extend('updatePermisions', $permisions);
		return $permisions;
	}

	public function canView($member = null)
	{
		return Permission::check(['MANAGE_CALENDAR_EVENT_CATEGORIES']);
	}

	public function canEdit($member = null)
	{
		return Permission::check(['MANAGE_CALENDAR_EVENT_CATEGORIES']);
	}

	public function canDelete($member = null)
	{
		return Permission::check(['MANAGE_CALENDAR_EVENT_CATEGORIES']);
	}

	public function canCreate($member = null, $context = array())
	{
		return Permission::check(['MANAGE_CALENDAR_EVENT_CATEGORIES']);
	}
}
